Subject: Re: [PATCH] amba: Retry adding deferred devices at late_initcall

From: Sudeep Holla <[email-masked]>
Date: Tue, 28 Apr 2020 16:51:32 +0100

On Mon, Apr 27, 2020 at 04:25:14PM -0500, Rob Herring wrote:
> If amba bus devices defer when adding, the amba bus code simply retries
> adding the devices every 5 seconds. This doesn't work well as it
> completely unsynchronized with starting the init process which can
> happen in less than 5 secs. Add a retry during late_initcall. If the
> amba devices are added, then deferred probe takes over. If the
> dependencies have not probed at this point, then there's no improvement
> over previous behavior. To completely solve this, we'd need to retry
> after every successful probe as deferred probe does.
>
> The list_empty() check now happens outside the mutex, but the mutex
> wasn't necessary in the first place.
>
> This needed to use deferred probe instead of fragile initcall ordering
> on 32-bit VExpress systems where the apb_pclk has a number of probe
> dependencies (vexpress-sysregs, vexpress-config).
>
> Cc: John Stultz <[email-masked]>
> Cc: Saravana Kannan <[email-masked]>
> Cc: Linus Walleij <[email-masked]>
> Cc: Sudeep Holla <[email-masked]>

The change makes sense to me,
Reviewed-by: Sudeep Holla <[email-masked]>

This also fixed the issue I reported @[1] is fixed with this patch, so:
Tested-by: Sudeep Holla <[email-masked]>

--
Regards,
Sudeep

[1] https://lore.kernel.org/linux-arm-kernel/20200423133342.GA10628@bogus/

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel